//+------------------------------------------------------------------+
//|                                           T3MA CustomCandles.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012 Pullback"
#property link      ""
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 DarkGray//wick
#property indicator_color2 Maroon//wick
#property indicator_color3 White//candle
#property indicator_color4 Red//candle
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 2



//---- GCCI settings

extern int Periods=12;

//---- input parameters
extern int	BarWidth			= 1,
				CandleWidth		= 2;

//---- buffers
double Bar1[],
		 Bar2[],
		 Candle1[],
		 Candle2[];
		 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
	IndicatorShortName("Pullback T3MA Candles");
	IndicatorBuffers(6);
	SetIndexBuffer(0,Bar1);
	SetIndexBuffer(1,Bar2);
	SetIndexBuffer(2,Candle1);
	SetIndexBuffer(3,Candle2);
	SetIndexStyle(0,DRAW_HISTOGRAM,0,BarWidth);
	SetIndexStyle(1,DRAW_HISTOGRAM,0,BarWidth);
	SetIndexStyle(2,DRAW_HISTOGRAM,0,CandleWidth);
	SetIndexStyle(3,DRAW_HISTOGRAM,0,CandleWidth);


	return(0);
}

//+------------------------------------------------------------------+
double TMA	(int i = 0)	{

return(iCustom(NULL,0,"T3MA",Periods,0,i));
}



//+------------------------------------------------------------------+
void SetCandleColor(int col, int i)
{
	double high,low,bodyHigh,bodyLow;


	{
		bodyHigh = MathMax(Open[i],Close[i]);
		bodyLow  = MathMin(Open[i],Close[i]);
		high		= High[i];
		low		= Low[i];
	}

	Bar1[i] = low;	Candle1[i] = bodyLow;
	Bar2[i] = low;	Candle2[i] = bodyLow;


	switch(col)
	{
		case 1: 	Bar1[i] = high;	Candle1[i] = bodyHigh; break;
		case 2: 	Bar2[i] = high;	Candle2[i] = bodyHigh; break;
	}
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
	for(int i = MathMax(Bars-1-IndicatorCounted(),1); i>=0; i--)
	{
		double	tma	= TMA(i);		
      double	tma1	= TMA(i-1);
		if(tma < tma1)		SetCandleColor(1,i);
		if(tma > tma1)		SetCandleColor(2,i);
				
	}
	

	return(0);
}
//+------------------------------------------------------------------+

